defmodule DecentralisedBookIndex.Metadata do
  use Ash.Domain,
    otp_app: :decentralised_book_index

  resources do
    resource DecentralisedBookIndex.Metadata.Book

    resource DecentralisedBookIndex.Metadata.Author do
      define :create_author, action: :create, args: [:name, :description, :author_alias_registry_id]
      define :add_author_to_alias_registry, action: :add_author_to_alias_registry, args: [:author_alias_registry_id]
      define :list_authors, action: :read
      define :get_author_by_id, args: [:id], action: :by_id
      define :update_author, action: :update
      define :destroy_author, action: :destroy
    end

    resource DecentralisedBookIndex.Metadata.DBIServer

    resource DecentralisedBookIndex.Metadata.AuthorAliasRegistry do
      define :create_author_alias_registry, action: :create
      define :list_author_alias_registries, action: :read
      define :get_author_alias_registry_by_id, args: [:id], action: :by_id
      define :update_author_alias_registry, action: :update
      define :destroy_author_alias_registry, action: :destroy
    end
  end
end
